/*	$Id: sandbox-tame.c,v 1.2 2015/08/06 20:37:37 kristaps Exp $ */
/*
 * Copyright (c) 2015 Kristaps Dzonsons <kristaps@bsd.lv>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_TAME

#include <sys/tame.h>

#include <stdarg.h>

#include "kcgi.h"
#include "extern.h"

int
ksandbox_tame_init_child(void *arg, enum sandtype type)
{
	int	 fl;

	fl = TAME_STDIO;
	if (SAND_CONTROL == type)
		fl |= TAME_UNIX | TAME_CMSG;

	if (-1 == tame(fl)) {
		XWARN("tame: %s", 
			SAND_CONTROL == type ?  
			"control" : "worker");
		return(0);
	}
	return(1);
}

#else
int dummy;
#endif
